`include "defines.vh"
`timescale 1ns / 1ps
module cpu_test;
    // Inputs
    reg clk;
    reg reset;

    // Outputs
    wire [7:0] porta;
    wire [7:0] portb;
    reg  [7:0] portb_value;
    
    // Instantiate the Unit Under Test (UUT)
    cpu #(
        .DATA_WIDTH(8),         // registers are 8 bits in width
        .INSTR_WIDTH(16),       // instructions are 16 bits in width
        .I_ADDR_WIDTH(10),      // 2 * 1024 bytes of flash (or ROM in our case)
        .D_ADDR_WIDTH(7),       // 128 bytes of SRAM
        .R_ADDR_WIDTH(5)        // 32 registers
    ) uut (
        .osc_clk(clk), 
        .trace_mode(0),
        .prescaler(0),
        .reset(reset),
        .porta(porta),
        .portb(portb) 
    );   

    assign portb = portb_value;

    initial begin
        // Initialize Inputs
        clk = 1;
        reset = 0;
        portb_value = 'h55;
        // Wait 10 ns for global reset to finish
        #10;
        reset = 1;
    end
    always clk = #5 ~clk;

endmodule
