module rom #(
        parameter   DATA_WIDTH = 16,
        parameter   ADDR_WIDTH = 8          // 2 * 1024 bytes of ROM
    )(
        input  wire                  clk,
        input  wire [ADDR_WIDTH-1:0] addr,  // here comes the program counter
        output wire [DATA_WIDTH-1:0] data   // here goes the instruction
    );

    reg [DATA_WIDTH-1:0] value;

    always @* begin
        case (addr)
        /* TODO 2: scrieti valorile corecte in DDRA si DDRB astfel incat sa puteti citi din PINB si scrie in PORTA. */
        /* TODO 5: rescrieti programul de mai jos astfel incat sa foloseasca instructiunile sbi si cbi. */
        

		  // ================ INITIAL CODE ===============
        /* rjmp to 3 => k = 2 */
        0:              value = 16'b1100_0000_0000_0010;
        /* adc R16, R16 */
        1:              value = 16'b0001_1111_0000_0000;
        /* ret */
        2:              value = 16'b1001_0101_0000_1000;
        /* ldi R16, low(RAMEND) = 0xBF */
        3:              value = 16'b1110_1011_0000_1111;
        /* out SPL, R16 (SPL = 0x3D) */
        4:              value = 16'b1011_1111_0000_1101;
        /* ldi R16, 0xFF */
        5:              value = 16'b1110_1111_0000_1111;
        /* out DDRA, R16 (set everything as output), DDRA = 0x01 */
        6:              value = 16'b1011_1001_0000_0001;
        /* ldi R16, 1 */
        7:              value = 16'b1110_0000_0000_0001;
        /* out PORTA, R16 (PORTA = 0x02) */
        8:              value = 16'b1011_1001_0000_0010;
        /* rcall to 1 => k = -9 */
        9:              value = 16'b1101_1111_1111_0111;
        /* rjmp  to 8 => k = -3 */
        10:             value = 16'b1100_1111_1111_1101;
        /* nop */
        default:        value = 0;
        endcase
    end
    assign data = value;

endmodule
